//+------------------------------------------------------------------
//|  BreakEvenExpert_V1 and Close on EMA Cross                                                                
//+------------------------------------------------------------------
//
#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

//---- input parameters
extern int FastEma   = 3;
extern int SlowEma   = 20;
extern int Price     = PRICE_CLOSE;
extern int BarToTest = 0;
extern double BreakEven = 40;    // Profit Lock in pips  

int      digit=0;

int init()   { 
   digit  = MarketInfo(Symbol(),MODE_DIGITS);
   return (0); 
}
int deinit() { return (0); }
int start()
  {
     
   if (ScanTrades()<1) return(0);
   void CheckToClose();
{        
   int total=OrdersTotal();
   double macdc = iMA(NULL,0,FastEma,0,MODE_EMA,Price,BarToTest  )-iMA(NULL,0,SlowEma,0,MODE_EMA,Price,BarToTest  );
   double macdp = iMA(NULL,0,FastEma,0,MODE_EMA,Price,BarToTest+1)-iMA(NULL,0,SlowEma,0,MODE_EMA,Price,BarToTest+1);
    for (int cnt=0;cnt<total;cnt++)
    { 
     OrderSelect(cnt, SELECT_BY_POS);   
     int mode=OrderType();    
        if ( OrderSymbol()==Symbol() ) 
        {
            if ( mode==OP_BUY )
            {
               if (macdp>0 && macdc<0)
               { 
               OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet);
			      return(0);
			      }
			   }
            if ( mode==OP_SELL )
            {
               if (macdp<0 && macdc>0) 
               {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet);
               return(0);
               }
            }
         }   
      } 
}

   else
   if (BreakEven>0) TrailStops(); 
   double macdc = iMA(NULL,0,FastEma,0,MODE_EMA,Price,BarToTest  )-iMA(NULL,0,SlowEma,0,MODE_EMA,Price,BarToTest  );
   double macdp = iMA(NULL,0,FastEma,0,MODE_EMA,Price,BarToTest+1)-iMA(NULL,0,SlowEma,0,MODE_EMA,Price,BarToTest+1);
      if (macdc>0 && macdp>0) return(0);
      if (macdc<0 && macdp<0) return(0);
   
      //
      //
      //
      //
      //
      
      for (int i=OrdersTotal()-1; i>=0; i--)
      {
         if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
         if (OrderSymbol()!=Symbol())                   continue;
         
         //
         //
         //
         //
         //
         
         int type   = OrderType();
         int ticket = OrderTicket();
            switch (type)
            {
               case OP_BUY       :
               case OP_SELL      : OrderClose(ticket,OrderLots(),OrderClosePrice(),0,Red); break;
               case OP_BUYSTOP   :
               case OP_BUYLIMIT  :
               case OP_SELLSTOP  :
               case OP_SELLLIMIT : OrderDelete(ticket); break;
               default : break;
            }
      }
//   return (0); 
  }

// ---- Trailing Stops
void TrailStops()
{        
    int total=OrdersTotal();
    for (int cnt=0;cnt<total;cnt++)
    { 
     OrderSelect(cnt, SELECT_BY_POS);   
     int mode=OrderType();    
        if ( OrderSymbol()==Symbol() ) 
        {
            if ( mode==OP_BUY )
            {
               if ( Bid-OrderOpenPrice()>Point*BreakEven ) 
               {
               double BuyStop = OrderOpenPrice();
               OrderModify(OrderTicket(),OrderOpenPrice(),
                           NormalizeDouble(BuyStop, digit),
                           OrderTakeProfit(),0,LightGreen);
			      return(0);
			      }
			   }
            if ( mode==OP_SELL )
            {
               if ( OrderOpenPrice()-Ask>Point*BreakEven ) 
               {
               double SellStop = OrderOpenPrice();
               OrderModify(OrderTicket(),OrderOpenPrice(),
   		                  NormalizeDouble(SellStop, digit),
   		                  OrderTakeProfit(),0,Yellow);	    
               return(0);
               }    
            }
         }   
      } 
}

// ---- Scan Trades
int ScanTrades()
{   
   int total = OrdersTotal();
   int numords = 0;
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if(OrderSymbol() == Symbol() && OrderType()<=OP_SELL) 
   numords++;
   }
   return(numords);
}


